#include <sys/wait.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <unistd.h>
#include <unistd.h>
#include <sys/mman.h>

int main(int argc, char* argv[]) {
    char * line1=NULL;
    char * line2=NULL;
    size_t len1=0, len2=0;
    /* ------ create and read matrixs ------ */
    if(argc<3){
    	fprintf(stderr, "Need to include 2 files\n");
        return EXIT_FAILURE;
    }
    if(argc>3){
    	fprintf(stderr, "Need to include only 2 files\n");
        return EXIT_FAILURE;
    }
    FILE *f1= fopen(argv[1], "r");
    if (!f1){
        fprintf(stderr, "Error opening file '%s'\n", argv[1]);
        return EXIT_FAILURE;
    }
    FILE *f2= fopen(argv[2], "r");
    if (!f2){
        fprintf(stderr, "Error opening file '%s'\n", argv[2]);
        return EXIT_FAILURE;
    }
    getline(&line2, &len2, f2);
    char * size = strtok(line2, "x");
    int n = atoi(size);
    size = strtok(NULL, "x");
    int m= atoi(size);
    getline(&line1, &len1, f1);
    int matrix1[n][m], matrix2[n][m];
    int i = 0, j = 0;
    while ( getline(&line2, &len2, f2) > 0) {
        char* token = strtok(line2," ");
        while( token != NULL ) {
            matrix2[i][j]=atoi(token);
            token=strtok(NULL," ");
            j++;
        }
        i++;
        j=0;
    }
    i=0; j=0;
    while ( getline(&line1, &len1, f1) > 0) {
        char* token = strtok(line1," ");
        while( token != NULL ) {
            matrix1[i][j]=atoi(token);
            token=strtok(NULL," ");
            j++;
        }
        i++;
        j=0;
    }
    fclose(f1);
    fclose(f2);
    /* ------ setup shared memory ------ */
    int *partials = mmap(NULL, m*n*sizeof(int), PROT_READ|PROT_WRITE,
    MAP_SHARED|MAP_ANONYMOUS, 0, 0);
    if(partials == MAP_FAILED){
        perror("mmap");
        exit(EXIT_FAILURE);
    }
    /* ------ start nprocs and do work ------ */
    for(i = 0; i < m; i++) {
        pid_t pid;
        if ((pid = fork()) < 0) {
            perror("fork");
            exit(EXIT_FAILURE);
        }
        if(pid == 0) {
                for(int j = 0; j < n; j++){
                    partials[i*n+j]=matrix1[j][i]+matrix2[j][i]; // integer to string
                }
            exit(EXIT_SUCCESS);
        }
    }
    /* ------ wait for nprocs to finish ------- */
    for(i = 0; i < m; i++) {
        if ( waitpid(-1, NULL, 0) < 0) {
            perror("waitpid");
            exit(EXIT_FAILURE);
        }
    }
    printf("%dx%d\n", n, m);
    for(i = 0; i < n; i++){
        for(int j=0; j<m; j++){
            printf("%d ",partials[i+j*n]);    
        }
        printf("\n");
    }
        
    /* ------ release shared memory ------ */
    if (munmap(partials, sizeof(partials)) < 0) {
        perror("munmap");
        exit(EXIT_FAILURE);
    }
    exit(EXIT_SUCCESS);
}
