#include <sys/wait.h>
#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <limits.h>
#define READ_END 0
#define WRITE_END 1
#define SIZE 999999
char* replaceWord(char* s, const char* oldW, const char* newW) {
    char* result;
    int i, cnt = 0;
    int newWlen = strlen(newW);
    int oldWlen = strlen(oldW);

    for (i = 0; s[i] != '\0'; i++) {
        if (strstr(&s[i], oldW) == &s[i]) {
            cnt++;
            i += oldWlen - 1;
        }
    }

    result = (char*)malloc(i + cnt * (newWlen - oldWlen) + 1);

    i = 0;
    while (*s) {
        if (strstr(s, oldW) == s) {
            strcpy(&result[i], newW);
            i += newWlen;
            s += oldWlen;
        }
        else if(strstr(s, newW) == s){
            strcpy(&result[i], oldW);
            i += oldWlen;
            s += newWlen;
        }
        else
            result[i++] = *s++;
    }

    result[i] = '\0';
    return result;
}


char* read_file(int * i, char * message) {
    char line[1000];



    FILE *file = fopen("cypher.txt", "r");
    if (file == NULL)
    {
        fputs("Failed to open cypher file\n", stderr);
        *i = -1;
        return NULL;
    }
    while(fgets(line,sizeof (line), file)){
        char *oldW = strtok(line," ");
        char *newW = strtok(NULL, " ");
        oldW = strtok(oldW, "\n");
        newW = strtok(newW, "\n");
        oldW = strtok(oldW, "\0");
        newW = strtok(newW, "\0");
        message = replaceWord(message, oldW, newW);
    }
    fclose(file);
    return message;
}


int main(int argc, char* argv[]) {
    int fd1[2], fd2[2];
    pid_t pid;
    char message[SIZE]={'\0'};

    if (pipe(fd1) < 0) {
        perror("pipe error");
        exit(EXIT_FAILURE);
    }

    if (pipe(fd2) < 0) {
        perror("pipe error");
        exit(EXIT_FAILURE);
    }

    pid = fork();
    if (pid < 0) {
        perror("fork error");
        exit(EXIT_FAILURE);
    }
    else if (pid > 0) {
        close(fd1[READ_END]);
        close(fd2[WRITE_END]);
        while (fgets(message, SIZE, stdin) != NULL)
        {
            int len = strlen(message);
            message[len - 1] = '\0';
            if (write(fd1[WRITE_END], message, strlen(message)+1) < 0) {
                fprintf(stderr, "Cannot 1 write to pipe: %s\n", strerror(errno));
            }

            if (read(fd2[READ_END], message, SIZE) < 0) {
                fprintf(stderr, "Cannot 2 read from pipe: %s\n", strerror(errno));
            }

            printf("%s\n", message);

        }
        close(fd1[WRITE_END]);
        close(fd2[READ_END]);
    }
    else {
        while(1){
            close(fd1[WRITE_END]);
            close(fd2[READ_END]);
            if (read(fd1[READ_END], message, SIZE) < 0) {
                fprintf(stderr, "Cannot read from pipe: %s\n", strerror(errno));
                break;
            }

            int error=0;
            char * result=read_file(&error, message);
            if (error == -1)
                return -1;

            if (write(fd2[WRITE_END], result, strlen(result)+1) < 0) {
                fprintf(stderr, "Cannot write to pipe: %s\n", strerror(errno));
            }
        }

        close(fd2[WRITE_END]);
        close(fd1[READ_END]);
    }
    exit(EXIT_SUCCESS);
}


